/////////////////////////////////////////////////////////////////////////////
//  P C 6 0 0 1 V
//  Copyright 1999 Yumitaro
/////////////////////////////////////////////////////////////////////////////
// Based on SLibrary.
/////////////////////////////////////////////////////////////////////////////
// This class is produced by AST. Check homepage when you need any help.
// Mail Address.    ast@qt-space.com
// Official HP URL. http://ast.qt-space.com/
/////////////////////////////////////////////////////////////////////////////
#include <SDL.h>

#include "csemaphore.h"


/////////////////////////////////////////////////////////////////////////////
// Mutex クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cMutex::cMutex( void )
{
	mtx = (HCRSECT)SDL_CreateMutex();
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cMutex::~cMutex( void )
{
	SDL_DestroyMutex( (SDL_mutex*)mtx );
}


/////////////////////////////////////////////////////////////////////////////
// Lock
/////////////////////////////////////////////////////////////////////////////
void cMutex::lock( void )
{
	if( mtx ){
		SDL_LockMutex( (SDL_mutex*)mtx );
	}
}


/////////////////////////////////////////////////////////////////////////////
// Unlock
/////////////////////////////////////////////////////////////////////////////
void cMutex::unlock( void )
{
	if( mtx ){
		SDL_UnlockMutex( (SDL_mutex*)mtx );
	}
}




/////////////////////////////////////////////////////////////////////////////
// RecursiveMutex クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cRecursiveMutex::cRecursiveMutex( void )
{
	mtx = (HCRSECT)SDL_CreateMutex();
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cRecursiveMutex::~cRecursiveMutex( void )
{
	SDL_DestroyMutex( (SDL_mutex*)mtx );
}


/////////////////////////////////////////////////////////////////////////////
// Lock
/////////////////////////////////////////////////////////////////////////////
void cRecursiveMutex::lock( void )
{
	if( mtx ){
		SDL_LockMutex( (SDL_mutex*)mtx );
	}
}


/////////////////////////////////////////////////////////////////////////////
// Unlock
/////////////////////////////////////////////////////////////////////////////
void cRecursiveMutex::unlock( void )
{
	if( mtx ){
		SDL_UnlockMutex( (SDL_mutex*)mtx );
	}
}




/////////////////////////////////////////////////////////////////////////////
// Semaphore クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::cSemaphore( void )
{
	sem = (HSEMAPHORE)SDL_CreateSemaphore( 0 );
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::~cSemaphore( void )
{
	if( sem ){
		SDL_DestroySemaphore( (SDL_sem*)sem );
	}
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ加算
//
// 引数:	なし
// 返値:	0：成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Post( void )
{
	return SDL_SemPost( (SDL_sem*)sem );
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ待つ
//
// 引数:	なし
// 返値:	0：成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Wait( void )
{
	return SDL_SemWait( (SDL_sem*)sem );
}
