/////////////////////////////////////////////////////////////////////////////
//  P C 6 0 0 1 V
//  Copyright 1999 Yumitaro
/////////////////////////////////////////////////////////////////////////////
// Based on SLibrary.
/////////////////////////////////////////////////////////////////////////////
// This class is produced by AST. Check homepage when you need any help.
// Mail Address.    ast@qt-space.com
// Official HP URL. http://ast.qt-space.com/
/////////////////////////////////////////////////////////////////////////////
#include "csemaphore.h"


/////////////////////////////////////////////////////////////////////////////
// Mutex クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cMutex::cMutex( void )
{
	mtx = (HCRSECT) new CRITICAL_SECTION;
	InitializeCriticalSection( (LPCRITICAL_SECTION)mtx );
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cMutex::~cMutex( void )
{
	if( mtx ){
		DeleteCriticalSection( (LPCRITICAL_SECTION)mtx );
	}
}


/////////////////////////////////////////////////////////////////////////////
// Lock
/////////////////////////////////////////////////////////////////////////////
void cMutex::lock( void )
{
	if( mtx ){
		EnterCriticalSection( (LPCRITICAL_SECTION)mtx );
	}
}


/////////////////////////////////////////////////////////////////////////////
// Unlock
/////////////////////////////////////////////////////////////////////////////
void cMutex::unlock( void )
{
	if( mtx ){
		LeaveCriticalSection( (LPCRITICAL_SECTION)mtx );
	}
}




/////////////////////////////////////////////////////////////////////////////
// Semaphore クラス
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::cSemaphore( void ) : count( 0 )
{
	sem = (HSEMAPHORE)CreateSemaphore( nullptr, 0, 32 * 1024, nullptr );
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
cSemaphore::~cSemaphore( void )
{
	if( sem ){
		CloseHandle( (HANDLE)sem );
	}
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ加算
//
// 引数:	なし
// 返値:	0:成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Post( void )
{
	InterlockedIncrement( &count );
	if( !ReleaseSemaphore( (HANDLE)sem, 1, nullptr ) ){
		InterlockedDecrement( &count );
		return -1;
	}
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// セマフォ待つ
//
// 引数:	なし
// 返値:	0:成功 -1:失敗
/////////////////////////////////////////////////////////////////////////////
int cSemaphore::Wait( void )
{
	int ret = -1;
	
	switch( WaitForSingleObject( (HANDLE)sem, INFINITE ) ){
    case WAIT_OBJECT_0:
		InterlockedDecrement( &count );
		ret = 0;
		break;
		
    case WAIT_TIMEOUT:
		ret = 1;
		break;
	}
	
	return ret;
}
